/* this is a monte carlo analysis of a sup(Wald/LM) test based on
efficient bounds of Altissimo and Corradi*/
/*It computes how many times the correct model is chosen*/
/*written by Ana Galvo, february 2004*/
new; 
output file=montecarlo2.out reset;
format /mb1 /rdc 6, 3;

tpi=timedt; print tpi; 
/*DGP*/
/*matrix with constant, coeficientes for all regimes*//*this is for linear*/
fimatl={0 0.5, 0.4 0, 0.5 0.8};
/* this is for non-linear*/
fimatt={0 0.5 0 0.5, 0.4 0 0.4 0, 0.8 0.8 0 0.8};
/* this is for structural break*/
fimatsb={0 0.4 0 0.6, 0.4 0 0.4 0, 0.8 0.8 0 0.8};
/*this is for sbt*/
fimatsbt={0 0.4 0 0.4 0 0.6 0 0.6, 0.4 0 0.4 0 0.4 0 0.4 0, 
         0.8 0.8 0 0.8 0.3 0.8 0 0.8};
/* thresholds*/
/*rsbt={1.6, 2.7};*/
rsbt={2, 3};
rt={2.5};
/*globals for estimation*/
pr2=.30;
prt=.15;
pr=.15;
/*break*/
bre={200};
/*number of observations*/
n=400;
/* monte carlo replications*/
rep=1000;
wald=zeros(rep,5);/* it need to change from Wald to LM and
                    from homo to hetero directly in the code*/
				   /* now it is set for heteroscedasticity and LM test*/
				   /*It need to change name of procedures in the main program
				   for Wald if necessary*/
load err1; load err2;


/* simulating data*/
yl=zeros(n+30,2);
yt=zeros(n+30,2);
ysb=zeros(n+30,2);
ysbtc=zeros(n+30,2);
ysbt=zeros(n+30,2);



for ns (2, n+30, 1); 
u=err1[ns,nr]~err2[ns,nr]; 
tu=ns@-(230*floor(ns/230))@;
ub=(u[1]*sqrt(2))~u[2];
yl[ns,.]=(1~yl[ns-1,.])*fimatl+u;
yt[ns,.]=(((1~yt[ns-1,.])*fimatt[.,1:2]+ub).*(yt[ns-1,2].<=rt))+
       (((1~yt[ns-1,.])*fimatt[.,3:4]+u).*(yt[ns-1,2].>rt));
ysb[ns,.]=((((1~ysb[ns-1,.])*fimatsb[.,1:2])+ub).*(tu.<=bre+30))+
         ((((1~ysb[ns-1,.])*fimatsb[.,3:4])+u).*(tu.>bre+30));
ysbtc[ns,.]=((((1~ysbtc[ns-1,.])*fimatsbt[.,1:2]+ub).*(ysbtc[ns-1,2].<=rt))+
          (((1~ysbtc[ns-1,.])*fimatsbt[.,3:4]+ub).*(ysbtc[ns-1,2].>rt))).*(tu.<=bre+30)+
          ((((1~ysbtc[ns-1,.])*fimatsbt[.,5:6]+u).*(ysbtc[ns-1,2].<=rt))+
          (((1~ysbtc[ns-1,.])*fimatsbt[.,7:8]+u).*(ysbtc[ns-1,2].>rt))).*(tu.>bre+30);
ysbt[ns,.]=((((1~ysbt[ns-1,.])*fimatsbt[.,1:2]+ub).*(ysbt[ns-1,2].<=rsbt[1]))+
          (((1~ysbt[ns-1,.])*fimatsbt[.,3:4]+ub).*(ysbt[ns-1,2].>rsbt[1]))).*(tu.<=bre+30)+
          ((((1~ysbt[ns-1,.])*fimatsbt[.,5:6]+u).*(ysbt[ns-1,2].<=rsbt[2]))+
          (((1~ysbt[ns-1,.])*fimatsbt[.,7:8]+u).*(ysbt[ns-1,2].>rsbt[2]))).*(tu.>bre+30);
endfor; 

/*dat=yt[31:rows(yt),.]~ysb[31:rows(ysb),.]~ysbt[31:rows(ysbt),.]~ysbtc[31:rows(ysbtc),.];
print dat;*/ 
yl=yl[31:rows(yl),.];
yt=yt[31:rows(yt),.];
ysb=ysb[31:rows(ysb),.];
ysbtc=ysbtc[31:rows(ysbtc),.];
ysbt=ysbt[31:rows(ysbt),.];

/*using the linear dgp*/
yesl=trimr(yl,1,0);
xesl=ones(n-1,1)~yl[1:n-1,.];
qesl=yl[1:n-1,2];
{lmli}=lmspec(yesl,xesl,qesl);
wald[nr,1]=lmli;
/*using threshold dgp*/
yet=trimr(yt,1,0);
xet=ones(n-1,1)~yt[1:n-1,.];
qet=yt[1:n-1,2];
{lmti}=lmspec(yet,xet,qet);
wald[nr,2]=lmti;
/*using break dgp*/
yesb=trimr(ysb,1,0);
xesb=ones(n-1,1)~ysb[1:n-1,.];
qesb=ysb[1:n-1,2];
{lmsbi}=lmspec(yesb,xesb,qesb);
wald[nr,3]=lmsbi;
/*using sbtc dgp*/
yesbtc=trimr(ysbtc,1,0);
xesbtc=ones(n-1,1)~ysbtc[1:n-1,.];
qesbtc=ysbtc[1:n-1,2];
{lmsbtci}=lmspec(yesbtc,xesbtc,qesbtc);
wald[nr,4]=lmsbtci;
/*using sbt dgp*/
yesbt=trimr(ysbt,1,0);
xesbt=ones(n-1,1)~ysbt[1:n-1,.];
qesbt=ysbt[1:n-1,2];
{lmsbti}=lmspec(yesbt,xesbt,qesbt);
wald[nr,5]=lmsbti;
endfor; 

"results ";
print wald;

"choice rate";
"linear dgp";
choice1=((rows(selif(wald[.,1],(wald[.,1].==1))))/rep)~
((rows(selif(wald[.,1],(wald[.,1].==2))))/rep)~
((rows(selif(wald[.,1],(wald[.,1].==3))))/rep)~
((rows(selif(wald[.,1],(wald[.,1].==4))))/rep)~
((rows(selif(wald[.,1],(wald[.,1].==5))))/rep);
print choice1; 
"tvar dgp";
choice2=((rows(selif(wald[.,2],(wald[.,2].==1))))/rep)~
((rows(selif(wald[.,2],(wald[.,2].==2))))/rep)~
((rows(selif(wald[.,2],(wald[.,2].==3))))/rep)~
((rows(selif(wald[.,2],(wald[.,2].==4))))/rep)~
((rows(selif(wald[.,2],(wald[.,2].==5))))/rep);
print choice2; 
"sbvar dgp";
choice3=((rows(selif(wald[.,3],(wald[.,3].==1))))/rep)~
((rows(selif(wald[.,3],(wald[.,3].==2))))/rep)~
((rows(selif(wald[.,3],(wald[.,3].==3))))/rep)~
((rows(selif(wald[.,3],(wald[.,3].==4))))/rep)~
((rows(selif(wald[.,3],(wald[.,3].==5))))/rep);
print choice3;
"stvarc dgp";
choice4=((rows(selif(wald[.,4],(wald[.,4].==1))))/rep)~
((rows(selif(wald[.,4],(wald[.,4].==2))))/rep)~
((rows(selif(wald[.,4],(wald[.,4].==3))))/rep)~
((rows(selif(wald[.,4],(wald[.,4].==4))))/rep)~
((rows(selif(wald[.,4],(wald[.,4].==5))))/rep);
print choice4;
"sbtvar dgp";
choice5=((rows(selif(wald[.,5],(wald[.,5].==1))))/rep)~
((rows(selif(wald[.,5],(wald[.,5].==2))))/rep)~
((rows(selif(wald[.,5],(wald[.,5].==3))))/rep)~
((rows(selif(wald[.,5],(wald[.,5].==4))))/rep)~
((rows(selif(wald[.,5],(wald[.,5].==5))))/rep);
print choice5; 

tpi=timedt; print tpi;
 
end;




/************************************************************/
proc(1)=waldtest(y, x, q); 
local t, tim, cor, rrhat, elin, xt, et, w11, w12, tthat, xb, eb, w21, w22;
local tafj,rhatj,xtc, etc, xbtc, ebtc,xbc, ebc, w31, w32, w41, w42; 
local taf, rhat1, rhat2, xbtcc, ebtcc, xbt, ebt, w51, w52, w;    


t=rows(y);
tim=seqa(1,1,t);
cor=1/(2*ln(ln(t)));

{rrhat}=threest(y, x, q);
elin=y-x*(invpd(x'x)*(x'y));
xt=(x.*(q.<=rrhat))~(x.*(q.>rrhat));
et=y-xt*(invpd(xt'xt))*(xt'y);
w11=sqrt(n*(((elin[.,1]'elin[.,1])-(et[.,1]'et[.,1]))/(et[.,1]'et[.,1])));
w11=cor*w11;
w12=sqrt(n*(((elin[.,2]'elin[.,2])-(et[.,2]'et[.,2]))/(et[.,2]'et[.,2])));
w12=cor*w12;

{tthat}=sbest(y, x);
xb=(x.*(tim.<=tthat))~(x.*(tim.>tthat));
eb=y-xb*(invpd(xb'xb))*(xb'y);
w21=sqrt(n*(((elin[.,1]'elin[.,1])-(eb[.,1]'eb[.,1]))/(eb[.,1]'eb[.,1])));
w21=cor*w21;
w22=sqrt(n*(((elin[.,2]'elin[.,2])-(eb[.,2]'eb[.,2]))/(eb[.,2]'eb[.,2])));
w22=cor*w22;


{tafj, rhatj}=joint(y, x, q);
xtc=(x.*(q.<=rhatj))~(x.*(q.>rhatj));
etc=y-xtc*(invpd(xtc'xtc))*(xtc'y);
xbtc=(((x.*(q.<=rhatj))~(x.*(q.>rhatj))).*(tim.<=tafj))~
     (((x.*(q.<=rhatj))~(x.*(q.>rhatj))).*(tim.>tafj));
ebtc=y-xbtc*(invpd(xbtc'xbtc))*(xbtc'y);
w31=sqrt(n*(((etc[.,1]'etc[.,1])-(ebtc[.,1]'ebtc[.,1]))/(ebtc[.,1]'ebtc[.,1])));
w31=cor*w31;
w32=sqrt(n*(((etc[.,2]'etc[.,2])-(ebtc[.,2]'ebtc[.,2]))/(ebtc[.,2]'ebtc[.,2])));
w32=cor*w32;


xbc=(x.*(tim.<=tafj))~(x.*(tim.>tafj));
ebc=y-xbc*(invpd(xbc'xbc))*(xbc'y);
w41=sqrt(n*(((ebc[.,1]'ebc[.,1])-(ebtc[.,1]'ebtc[.,1]))/(ebtc[.,1]'ebtc[.,1])));
w41=cor*w41;
w42=sqrt(n*(((ebc[.,2]'ebc[.,2])-(ebtc[.,2]'ebtc[.,2]))/(ebtc[.,2]'ebtc[.,2])));
w42=cor*w42;


{taf,rhat1, rhat2}=tvtvar(y,x,q);
xbtcc=(((x.*(q.<=rhat1))~(x.*(q.>rhat1))).*(tim.<=taf))~
     (((x.*(q.<=rhat1))~(x.*(q.>rhat1))).*(tim.>taf));
ebtcc=y-xbtcc*(invpd(xbtcc'xbtcc))*(xbtcc'y);
xbt=(((x.*(q.<=rhat1))~(x.*(q.>rhat1))).*(tim.<=taf))~
     (((x.*(q.<=rhat2))~(x.*(q.>rhat2))).*(tim.>taf));
ebt=y-xbt*(invpd(xbt'xbt))*(xbt'y);
w51=sqrt(n*(((ebtcc[.,1]'ebtcc[.,1])-(ebt[.,1]'ebt[.,1]))/(ebt[.,1]'ebt[.,1])));
w51=cor*w51;
w52=sqrt(n*(((ebtcc[.,2]'ebtcc[.,2])-(ebt[.,2]'ebt[.,2]))/(ebt[.,2]'ebt[.,2])));
w52=cor*w52;

w=w11~w12~w21~w22~w31~w32~w41~w42~w51~w52; 

retp(w);
endp; 

proc(1)=waldspec(y, x, q); 
local t, tim, cor, rrhat, elin, xt, et, w1, tthat, xb, eb, w2;
local tafj,rhatj,xtc, etc, xbtc, ebtc,xbc, ebc, w3, w4; 
local taf, rhat1, rhat2, xbtcc, ebtcc, xbt, ebt, w5, w;    


t=rows(y);
tim=seqa(1,1,t);
cor=1/(2*ln(ln(t)));

{rrhat}=threest(y, x, q);
elin=y-x*(invpd(x'x)*(x'y));
xt=(x.*(q.<=rrhat))~(x.*(q.>rrhat));
et=y-xt*(invpd(xt'xt))*(xt'y);
w1=sqrt(n*((sumc(diag(elin'elin))-sumc(diag(et'et)))/sumc(diag(et'et))));
w1=cor*w1;


{tthat}=sbest(y, x);
xb=(x.*(tim.<=tthat))~(x.*(tim.>tthat));
eb=y-xb*(invpd(xb'xb))*(xb'y);
w2=sqrt(n*((sumc(diag(elin'elin))-sumc(diag(eb'eb)))/sumc(diag(eb'eb))));
w2=cor*w2;

if w1<=1 and w2<=1;
w=1;
/*elseif w1<=1 and w2>1;
w=3;
elseif w1>1 and w2<=1;
w=2;*/
else; 
if w1>w2;
{tafj, rhatj}=joint(y, x, q);
xbtc=(((x.*(q.<=rhatj))~(x.*(q.>rhatj))).*(tim.<=tafj))~
     (((x.*(q.<=rhatj))~(x.*(q.>rhatj))).*(tim.>tafj));
ebtc=y-xbtc*(invpd(xbtc'xbtc))*(xbtc'y);
w3=sqrt(n*((sumc(diag(et'et))-sumc(diag(ebtc'ebtc)))/sumc(diag(ebtc'ebtc))));
w3=cor*w3;
{taf,rhat1, rhat2}=tvtvar(y,x,q);
xbt=(((x.*(q.<=rhat1))~(x.*(q.>rhat1))).*(tim.<=taf))~
     (((x.*(q.<=rhat2))~(x.*(q.>rhat2))).*(tim.>taf));
ebt=y-xbt*(invpd(xbt'xbt))*(xbt'y);
w5=sqrt(n*((sumc(diag(et'et))-sumc(diag(ebt'ebt)))/sumc(diag(ebt'ebt))));
w5=cor*w5;

if w3<=1 and w5<=1; w=2;
elseif w3>w5; w=4;
else; w=5; endif; 

else;
{tafj, rhatj}=joint(y, x, q);
xbtc=(((x.*(q.<=rhatj))~(x.*(q.>rhatj))).*(tim.<=tafj))~
     (((x.*(q.<=rhatj))~(x.*(q.>rhatj))).*(tim.>tafj));
ebtc=y-xbtc*(invpd(xbtc'xbtc))*(xbtc'y);
w4=sqrt(n*((sumc(diag(eb'eb))-sumc(diag(ebtc'ebtc)))/sumc(diag(ebtc'ebtc))));
w4=cor*w4;
{taf,rhat1, rhat2}=tvtvar(y,x,q);
xbt=(((x.*(q.<=rhat1))~(x.*(q.>rhat1))).*(tim.<=taf))~
     (((x.*(q.<=rhat2))~(x.*(q.>rhat2))).*(tim.>taf));
ebt=y-xbt*(invpd(xbt'xbt))*(xbt'y);
w5=sqrt(n*((sumc(diag(eb'eb))-sumc(diag(ebt'ebt)))/sumc(diag(ebt'ebt))));
w5=cor*w5;

if w4<=1 and w5<=1; w=3;
elseif w4>w5; w=4;
else; w=5; endif; 

endif; 
endif; 

retp(w);
endp; 

proc(1)=lmspec(y, x, q); 
local t, tim, cor, rrhat, elin, xt, et, w1, tthat, xb, eb, w2;
local tafj,rhatj,xtc, etc, xbtc, ebtc,xbc, ebc, w3, w4; 
local taf, rhat1, rhat2, xbtcc, ebtcc, xbt, ebt, w5, w;    


t=rows(y);
tim=seqa(1,1,t);
cor=1/(2*ln(ln(t)));

{rrhat}=threest(y, x, q);
elin=y-x*(invpd(x'x)*(x'y));
xt=(x.*(q.<=rrhat))~(x.*(q.>rrhat));
et=y-xt*(invpd(xt'xt))*(xt'y);
w1=sqrt(n*((sumc(diag(elin'elin))-sumc(diag(et'et)))/sumc(diag(elin'elin))));
w1=cor*w1;


{tthat}=sbest(y, x);
xb=(x.*(tim.<=tthat))~(x.*(tim.>tthat));
eb=y-xb*(invpd(xb'xb))*(xb'y);
w2=sqrt(n*((sumc(diag(elin'elin))-sumc(diag(eb'eb)))/sumc(diag(elin'elin))));
w2=cor*w2;

if w1<=1 and w2<=1;
w=1;
/*elseif w1<=1 and w2>1;
w=3;
elseif w1>1 and w2<=1;
w=2;*/
else; 
if w1>w2;
{tafj, rhatj}=joint(y, x, q);
xbtc=(((x.*(q.<=rhatj))~(x.*(q.>rhatj))).*(tim.<=tafj))~
     (((x.*(q.<=rhatj))~(x.*(q.>rhatj))).*(tim.>tafj));
ebtc=y-xbtc*(invpd(xbtc'xbtc))*(xbtc'y);
w3=sqrt(n*((sumc(diag(et'et))-sumc(diag(ebtc'ebtc)))/sumc(diag(et'et))));
w3=cor*w3;
{taf,rhat1, rhat2}=tvtvar(y,x,q);
xbt=(((x.*(q.<=rhat1))~(x.*(q.>rhat1))).*(tim.<=taf))~
     (((x.*(q.<=rhat2))~(x.*(q.>rhat2))).*(tim.>taf));
ebt=y-xbt*(invpd(xbt'xbt))*(xbt'y);
w5=sqrt(n*((sumc(diag(et'et))-sumc(diag(ebt'ebt)))/sumc(diag(et'et))));
w5=cor*w5;

if w3<=1 and w5<=1; w=2;
elseif w3>w5; w=4;
else; w=5; endif; 

else;
{tafj, rhatj}=joint(y, x, q);
xbtc=(((x.*(q.<=rhatj))~(x.*(q.>rhatj))).*(tim.<=tafj))~
     (((x.*(q.<=rhatj))~(x.*(q.>rhatj))).*(tim.>tafj));
ebtc=y-xbtc*(invpd(xbtc'xbtc))*(xbtc'y);
w4=sqrt(n*((sumc(diag(eb'eb))-sumc(diag(ebtc'ebtc)))/sumc(diag(eb'eb))));
w4=cor*w4;
{taf,rhat1, rhat2}=tvtvar(y,x,q);
xbt=(((x.*(q.<=rhat1))~(x.*(q.>rhat1))).*(tim.<=taf))~
     (((x.*(q.<=rhat2))~(x.*(q.>rhat2))).*(tim.>taf));
ebt=y-xbt*(invpd(xbt'xbt))*(xbt'y);
w5=sqrt(n*((sumc(diag(eb'eb))-sumc(diag(ebt'ebt)))/sumc(diag(eb'eb))));
w5=cor*w5;

if w4<=1 and w5<=1; w=3;
elseif w4>w5; w=4;
else; w=5; endif; 

endif; 
endif; 

retp(w);
endp;  
proc(3) = tvtvar (y, x, q); 
local t, r1, r2, step, r, rr, ss, resu, xi1, yi1, qi1,qq1, qqr1, qqn1, s1;
local qqd, du, xi1l, yi1l, xi1h, yi1h, xi2l, yi2l, xi2h, yi2h,xi2, yi2,
qi2,qq2, qqr2, qqn2, s2, ui1l, ui2l, ui1h, ui2h, ti1, ti2;   
local sigl, sigh, st, taf, ghat1, ghat2; 

t=rows(y); 
r1=ceil(pr2*t); 
r2=floor((1-pr2)*t);
step=(r2-r1)/(.4*rows(y));
r=seqa(r1,step, (.4*rows(y)));
rr=rows(r);
ss=zeros(rr,2); 
resu=zeros(rr,2);

/*search over time */ 
for i (1, rr, 1);
/*the lower part */
xi1=x[1:r[i],.]; yi1=y[1:r[i],.]; qi1=q[1:r[i],.]; 
ti1=rows(xi1); 
/*the threshold estimation */
qq1=sortc(qi1[.,1],1);
qqr1=trimr(qq1, ceil(prt*ti1), ceil (prt*ti1));
qqn1=rows(qqr1);
s1=zeros(qqn1, 1);
for j (1, qqn1,1);   
qqd=qqr1[j];
du=(qi1.<=qqd);  
xi1l=selif(xi1,du); yi1l=selif(yi1,du); 
xi1h=delif(xi1,du); yi1h=delif(yi1,du);
ui1l=yi1l-xi1l*(invpd(xi1l'xi1l)*(xi1l'yi1l));
ui1h=yi1h-xi1h*(invpd(xi1h'xi1h)*(xi1h'yi1h)); 
sigl=(ui1l'ui1l)./rows(ui1l); sigh=(ui1h'ui1h)./rows(ui1h);
s1[j]=-rows(ui1l)*ln(det(sigl))-rows(ui1h)*ln(det(sigh));
endfor; 
ss[i,1]=maxc(s1);
resu[i,1]=qqr1[maxindc(s1)]; /*ghat1*/
/*the upper part */
xi2=x[r[i]+1:t,.]; yi2=y[r[i]+1:t,.]; qi2=q[r[i]+1:t,.]; 
ti2=rows(xi2); 
/*the threshold estimation */
qq2=sortc(qi2[.,1],1);
qqr2=trimr(qq2, ceil(prt*ti2), ceil (prt*ti2));
qqn2=rows(qqr2);
s2=zeros(qqn2,1);
for o (1, qqn2, 1);
qqd=qqr2[o];
du=(qi2.<=qqd);  
xi2l=selif(xi2,du); yi2l=selif(yi2,du); 
xi2h=delif(xi2,du); yi2h=delif(yi2,du);
ui2l=yi2l-xi2l*(invpd(xi2l'xi2l)*(xi2l'yi2l));
ui2h=yi2h-xi2h*(invpd(xi2h'xi2h)*(xi2h'yi2h)); 
sigl=(ui2l'ui2l)./rows(ui2l); sigh=(ui2h'ui2h)./rows(ui2h);
s2[o]=-rows(ui2l)*ln(det(sigl))-rows(ui2h)*ln(det(sigh));
endfor; 
ss[i,2]=maxc(s2);
resu[i,2]=qqr2[maxindc(s2)]; /*ghat2*/
endfor; 

st= ss[.,1]+ss[.,2];
taf=r1+maxindc(st);
/*taf=taf+dmax;*/
 
ghat1=resu[maxindc(st),1];
ghat2=resu[maxindc(st),2];

retp(taf, ghat1, ghat2); 
endp;

proc(1)=threest (y, x, q);
local t,qi, qq1, qq2, ra, qq, qqn, s, qqd, du, xl, xh, yl, yh, el, eh,
sil, sih, ghat;   

t=rows(y); 
qi=sortc(q[.,1],1);
qq1=qi[floor(t*pr)];
qq2=qi[floor(t*(1-pr))];
ra=((qq2-qq1)/100);
qq=seqa(qq1, ra, 100);
qqn=rows(qq);
s=zeros(qqn, 1);
 
for i(1, qqn, 1);
qqd=qq[i];
du=(q.<=qqd);  
xl=selif(x, du); xh=selif(x, (1-du));
yl=selif(y, du); yh=selif(y, (1-du));
el=yl-xl*invpd(xl'xl)*(xl'yl); 
eh=yh-xh*invpd(xh'xh)*(xh'yh);
sil=(el'el)/rows(el); sih=(eh'eh)/rows(eh); 
s[i]=rows(el)*ln(det(sil))+rows(eh)*ln(det(sih)); 
endfor; 
ghat=qq[minindc(s)];

retp(ghat);
endp; 

proc(1)=sbest (y, x);
local t,tim, qq1, qq2, ra, qq, qqn, s, qqd, du, xl, xh, yl, yh, el, eh,
sil, sih, that;   

t=rows(y); 
tim=seqa(1, 1, t);
qq1=tim[floor(t*pr)];
qq2=tim[floor(t*(1-pr))];
ra=((qq2-qq1)/100);
qq=seqa(qq1, ra, 100);
qqn=rows(qq);
s=zeros(qqn, 1);
 
for i(1, qqn, 1);
qqd=qq[i];
du=(tim.<=qqd);  
xl=selif(x, du); xh=selif(x, (1-du));
yl=selif(y, du); yh=selif(y, (1-du));
el=yl-xl*invpd(xl'xl)*(xl'yl); 
eh=yh-xh*invpd(xh'xh)*(xh'yh);
sil=(el'el)/rows(el); sih=(eh'eh)/rows(eh); 
s[i]=rows(el)*ln(det(sil))+rows(eh)*ln(det(sih)); 
endfor; 
that=qq[minindc(s)];

retp(that);
endp; 

proc(2)=joint(y, x, q); 
local  t, r1, r2, step, r, rr, st, gat, dt, tp, qt1, qt2, qt, s,qq1, qq2,
qd, qqd, q1x, q1n, q2x, q2n,qq, xi1, yi1, xi2, yi2,du1, xi1l,yi1l,
xi1h,yi1h,xi2l,yi2l,xi2h,yi2h,ui1l,ui1h,ui2l,ui2h,du2,sig1l, sig2l,
sig1h, sig2h, ghat, taf, qi1, qi2, nq;   

t=rows(y); 
r1=ceil(pr2*t); 
r2=floor((1-pr2)*t);
step=(r2-r1)/(.4*rows(y));
r=seqa(r1, step, (.4*rows(y)));
rr=rows(r);
st=zeros(rr,1); 
gat=zeros(rr,1);

for i(1,rr, 1); 
xi1=x[1:r[i],.]; yi1=y[1:r[i],.]; qi1=q[1:r[i],.]; 
xi2=x[r[i]+1:t,.]; yi2=y[r[i]+1:t,.]; qi2=q[r[i]+1:t,.]; 
qt1=sortc(qi1[.,1],1);
qt1=qt1[(floor(prt*rows(qt1)))+1:ceil((1-prt)*rows(qt1))];
qt2=sortc(qi2[.,1],1);
qt2=qt2[(floor(prt*rows(qt2)))+1:ceil((1-prt)*rows(qt2))];
q1x=maxc(qt1); q1n=minc(qt1);
q2x=maxc(qt2); q2n=minc(qt2);
qq1=minc(q1x|q2x); qq2=maxc(q1n|q2n);
qt=seqa(qq2, (qq1-qq2)/100, 100);
nq=rows(qt); 
s=zeros(nq,1);
for hh (1, nq, 1); 
qqd=qt[hh];
du1=(qi1.<=qqd);
xi1l=selif(xi1,du1); yi1l=selif(yi1,du1); 
xi1h=delif(xi1,du1); yi1h=delif(yi1,du1);
ui1l=yi1l-xi1l*(ginv(xi1l'xi1l)*(xi1l'yi1l));
ui1h=yi1h-xi1h*(ginv(xi1h'xi1h)*(xi1h'yi1h)); 
sig1l=(ui1l'ui1l)./rows(ui1l); sig1h=(ui1h'ui1h)./rows(ui1h);
du2=(qi2.<=qqd);
xi2l=selif(xi2,du2); yi2l=selif(yi2,du2); 
xi2h=delif(xi2,du2); yi2h=delif(yi2,du2);
ui2l=yi2l-xi2l*(ginv(xi2l'xi2l)*(xi2l'yi2l));
ui2h=yi2h-xi2h*(ginv(xi2h'xi2h)*(xi2h'yi2h)); 
sig2l=(ui2l'ui2l)./rows(ui2l); sig2h=(ui2h'ui2h)./rows(ui2h);
s[hh]=-rows(ui1l)*ln(det(sig1l))-rows(ui1h)*ln(det(sig1h))
      -rows(ui2l)*ln(det(sig2l))-rows(ui2h)*ln(det(sig2h)); 
endfor; 
st[i]=maxc(s);
gat[i]=qt[maxindc(s)];
endfor;
taf=r[1]-1+maxindc(st); 
ghat=gat[maxindc(st)];

retp(taf, ghat); 
endp; 


proc ginv(m);
local mi;
trap 1;
mi=invpd(m);
if scalerr(mi);
mi=pinv(m);
endif;
if scalerr(mi);
trap 0;
mi=invswp(m);
endif;
retp(mi);
endp;
